From 24d7957ce2c7e55ccc1a9f786f50a21160631078 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Sun, 15 Mar 2020 21:12:33 +0800
Subject: [PATCH 47/76] ath11k: set credit_update flag for flow controlled ep
 only

This change is required because firmware will check all the pipes
before entering WoW. If ATH11K_HTC_FLAG_NEED_CREDIT_UPDATE is set,
firmware treats this pipe needed to return credit even though it's
actually not required. If any pipe needs to return credit, the
suspend_complete message doesn't send to host but is dropped.
So host gets time out and WoW suspend failed.

Tested QCA6390 on X86 platform.

Change-Id: I869ebf225eb7bfabcf5cba0789e0298f80ef2611
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/htc.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/htc.c b/drivers/net/wireless/ath/ath11k/htc.c
index ad13c64..0069869 100644
--- a/drivers/net/wireless/ath/ath11k/htc.c
+++ b/drivers/net/wireless/ath/ath11k/htc.c
@@ -69,9 +69,11 @@ static void ath11k_htc_prepare_tx_skb(struct ath11k_htc_ep *ep,
 	memset(hdr, 0, sizeof(*hdr));
 	hdr->htc_info = FIELD_PREP(HTC_HDR_ENDPOINTID, ep->eid) |
 			FIELD_PREP(HTC_HDR_PAYLOADLEN,
-				   (skb->len - sizeof(*hdr))) |
-			FIELD_PREP(HTC_HDR_FLAGS,
-				   ATH11K_HTC_FLAG_NEED_CREDIT_UPDATE);
+				   (skb->len - sizeof(*hdr)));
+
+	if (ep->tx_credit_flow_enabled)
+		hdr->htc_info |= FIELD_PREP(HTC_HDR_FLAGS,
+					    ATH11K_HTC_FLAG_NEED_CREDIT_UPDATE);
 
 	spin_lock_bh(&ep->htc->tx_lock);
 	hdr->ctrl_info = FIELD_PREP(HTC_HDR_CONTROLBYTES1, ep->seq_no++);
-- 
2.7.4

